## GulkanBuffer

GulkanBuffer

## Functions

GulkanBuffer * | gulkan_buffer_new ()
GulkanBuffer * | gulkan_buffer_new_from_data ()
gboolean | gulkan_buffer_map ()
void | gulkan_buffer_unmap ()
gboolean | gulkan_buffer_upload ()
VkBuffer | gulkan_buffer_get_handle ()
VkDeviceMemory | gulkan_buffer_get_memory_handle ()

## Types and Values

#define | GULKAN_TYPE_BUFFER
| GulkanBuffer

## Object Hierarchy

        GObject
        ╰── GulkanBuffer

## Includes

    #include <gulkan.h>

## Description

## Functions

### gulkan_buffer_new ()

    GulkanBuffer *
    gulkan_buffer_new (GulkanDevice *device,
                       VkDeviceSize size,
                       VkBufferUsageFlags usage,
                       VkMemoryPropertyFlags properties);

### gulkan_buffer_new_from_data ()

    GulkanBuffer *
    gulkan_buffer_new_from_data (GulkanDevice *device,
                                 const void *data,
                                 VkDeviceSize size,
                                 VkBufferUsageFlags usage,
                                 VkMemoryPropertyFlags properties);

### gulkan_buffer_map ()

    gboolean
    gulkan_buffer_map (GulkanBuffer *self,
                       void **data);

### gulkan_buffer_unmap ()

    void
    gulkan_buffer_unmap (GulkanBuffer *self);

### gulkan_buffer_upload ()

    gboolean
    gulkan_buffer_upload (GulkanBuffer *self,
                          const void *data,
                          VkDeviceSize size);

### gulkan_buffer_get_handle ()

    VkBuffer
    gulkan_buffer_get_handle (GulkanBuffer *self);

### gulkan_buffer_get_memory_handle ()

    VkDeviceMemory
    gulkan_buffer_get_memory_handle (GulkanBuffer *self);

## Types and Values

### GULKAN_TYPE_BUFFER

    #define GULKAN_TYPE_BUFFER gulkan_buffer_get_type()

### GulkanBuffer

    typedef struct _GulkanBuffer GulkanBuffer;